~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/lib/bpf/Makefile

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /tools/lib/bpf/Makefile (Version linux-6.12-rc7) and /tools/lib/bpf/Makefile (Version linux-5.11.22)


  1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-      1 # SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
  2 # Most of this file is copied from tools/lib/t      2 # Most of this file is copied from tools/lib/traceevent/Makefile
  3                                                     3 
  4 RM ?= rm                                            4 RM ?= rm
  5 srctree := $(realpath $(srctree))              !!   5 srctree = $(abs_srctree)
  6                                                     6 
  7 VERSION_SCRIPT := libbpf.map                   << 
  8 LIBBPF_VERSION := $(shell \                         7 LIBBPF_VERSION := $(shell \
  9         grep -oE '^LIBBPF_([0-9.]+)' $(VERSION !!   8         grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
 10         sort -rV | head -n1 | cut -d'_' -f2)        9         sort -rV | head -n1 | cut -d'_' -f2)
 11 LIBBPF_MAJOR_VERSION := $(word 1,$(subst ., ,$ !!  10 LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))
 12 LIBBPF_MINOR_VERSION := $(word 2,$(subst ., ,$ << 
 13                                                    11 
 14 MAKEFLAGS += --no-print-directory                  12 MAKEFLAGS += --no-print-directory
 15                                                    13 
 16 # This will work when bpf is built in tools en     14 # This will work when bpf is built in tools env. where srctree
 17 # isn't set and when invoked from selftests bu     15 # isn't set and when invoked from selftests build, where srctree
 18 # is a ".". building_out_of_srctree is undefin     16 # is a ".". building_out_of_srctree is undefined for in srctree
 19 # builds                                           17 # builds
 20 ifndef building_out_of_srctree                     18 ifndef building_out_of_srctree
 21 srctree := $(patsubst %/,%,$(dir $(CURDIR)))       19 srctree := $(patsubst %/,%,$(dir $(CURDIR)))
 22 srctree := $(patsubst %/,%,$(dir $(srctree)))      20 srctree := $(patsubst %/,%,$(dir $(srctree)))
 23 srctree := $(patsubst %/,%,$(dir $(srctree)))      21 srctree := $(patsubst %/,%,$(dir $(srctree)))
 24 #$(info Determined 'srctree' to be $(srctree))     22 #$(info Determined 'srctree' to be $(srctree))
 25 endif                                              23 endif
 26                                                    24 
 27 INSTALL = install                                  25 INSTALL = install
 28                                                    26 
 29 # Use DESTDIR for installing into a different      27 # Use DESTDIR for installing into a different root directory.
 30 # This is useful for building a package. The p     28 # This is useful for building a package. The program will be
 31 # installed in this directory as if it was the     29 # installed in this directory as if it was the root directory.
 32 # Then the build tool can move it later.           30 # Then the build tool can move it later.
 33 DESTDIR ?=                                         31 DESTDIR ?=
 34 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'          32 DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'
 35                                                    33 
 36 include $(srctree)/tools/scripts/Makefile.arch     34 include $(srctree)/tools/scripts/Makefile.arch
 37                                                    35 
 38 ifeq ($(LP64), 1)                                  36 ifeq ($(LP64), 1)
 39   libdir_relative = lib64                          37   libdir_relative = lib64
 40 else                                               38 else
 41   libdir_relative = lib                            39   libdir_relative = lib
 42 endif                                              40 endif
 43                                                    41 
 44 prefix ?= /usr/local                               42 prefix ?= /usr/local
 45 libdir = $(prefix)/$(libdir_relative)              43 libdir = $(prefix)/$(libdir_relative)
 46 man_dir = $(prefix)/share/man                      44 man_dir = $(prefix)/share/man
 47 man_dir_SQ = '$(subst ','\'',$(man_dir))'          45 man_dir_SQ = '$(subst ','\'',$(man_dir))'
 48                                                    46 
 49 export man_dir man_dir_SQ INSTALL                  47 export man_dir man_dir_SQ INSTALL
 50 export DESTDIR DESTDIR_SQ                          48 export DESTDIR DESTDIR_SQ
 51                                                    49 
 52 include $(srctree)/tools/scripts/Makefile.incl     50 include $(srctree)/tools/scripts/Makefile.include
 53                                                    51 
 54 # copy a bit from Linux kbuild                     52 # copy a bit from Linux kbuild
 55                                                    53 
 56 ifeq ("$(origin V)", "command line")               54 ifeq ("$(origin V)", "command line")
 57   VERBOSE = $(V)                                   55   VERBOSE = $(V)
 58 endif                                              56 endif
 59 ifndef VERBOSE                                     57 ifndef VERBOSE
 60   VERBOSE = 0                                      58   VERBOSE = 0
 61 endif                                              59 endif
 62                                                    60 
 63 INCLUDES = -I$(or $(OUTPUT),.) \               !!  61 FEATURE_USER = .libbpf
 64            -I$(srctree)/tools/include -I$(srct !!  62 FEATURE_TESTS = libelf zlib bpf
                                                   >>  63 FEATURE_DISPLAY = libelf zlib bpf
                                                   >>  64 
                                                   >>  65 INCLUDES = -I. -I$(srctree)/tools/include -I$(srctree)/tools/include/uapi
                                                   >>  66 FEATURE_CHECK_CFLAGS-bpf = $(INCLUDES)
                                                   >>  67 
                                                   >>  68 check_feat := 1
                                                   >>  69 NON_CHECK_FEAT_TARGETS := clean TAGS tags cscope help
                                                   >>  70 ifdef MAKECMDGOALS
                                                   >>  71 ifeq ($(filter-out $(NON_CHECK_FEAT_TARGETS),$(MAKECMDGOALS)),)
                                                   >>  72   check_feat := 0
                                                   >>  73 endif
                                                   >>  74 endif
                                                   >>  75 
                                                   >>  76 ifeq ($(check_feat),1)
                                                   >>  77 ifeq ($(FEATURES_DUMP),)
                                                   >>  78 include $(srctree)/tools/build/Makefile.feature
                                                   >>  79 else
                                                   >>  80 include $(FEATURES_DUMP)
                                                   >>  81 endif
                                                   >>  82 endif
 65                                                    83 
 66 export prefix libdir src obj                       84 export prefix libdir src obj
 67                                                    85 
 68 # Shell quotes                                     86 # Shell quotes
 69 libdir_SQ = $(subst ','\'',$(libdir))              87 libdir_SQ = $(subst ','\'',$(libdir))
 70 libdir_relative_SQ = $(subst ','\'',$(libdir_r     88 libdir_relative_SQ = $(subst ','\'',$(libdir_relative))
 71                                                    89 
 72 OBJ             = $@                               90 OBJ             = $@
 73 N               =                                  91 N               =
 74                                                    92 
 75 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_     93 LIB_TARGET      = libbpf.a libbpf.so.$(LIBBPF_VERSION)
 76 LIB_FILE        = libbpf.a libbpf.so*              94 LIB_FILE        = libbpf.a libbpf.so*
 77 PC_FILE         = libbpf.pc                        95 PC_FILE         = libbpf.pc
 78                                                    96 
 79 # Set compile option CFLAGS                        97 # Set compile option CFLAGS
 80 ifdef EXTRA_CFLAGS                                 98 ifdef EXTRA_CFLAGS
 81   CFLAGS := $(EXTRA_CFLAGS)                        99   CFLAGS := $(EXTRA_CFLAGS)
 82 else                                              100 else
 83   CFLAGS := -g -O2                                101   CFLAGS := -g -O2
 84 endif                                             102 endif
 85                                                   103 
 86 # Append required CFLAGS                          104 # Append required CFLAGS
 87 override CFLAGS += -std=gnu89                  << 
 88 override CFLAGS += $(EXTRA_WARNINGS) -Wno-swit    105 override CFLAGS += $(EXTRA_WARNINGS) -Wno-switch-enum
 89 override CFLAGS += -Werror -Wall                  106 override CFLAGS += -Werror -Wall
 90 override CFLAGS += $(INCLUDES)                    107 override CFLAGS += $(INCLUDES)
 91 override CFLAGS += -fvisibility=hidden            108 override CFLAGS += -fvisibility=hidden
 92 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FI    109 override CFLAGS += -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 93 override CFLAGS += $(CLANG_CROSS_FLAGS)        << 
 94                                                   110 
 95 # flags specific for shared library               111 # flags specific for shared library
 96 SHLIB_FLAGS := -DSHARED -fPIC                     112 SHLIB_FLAGS := -DSHARED -fPIC
 97                                                   113 
 98 ifeq ($(VERBOSE),1)                               114 ifeq ($(VERBOSE),1)
 99   Q =                                             115   Q =
100 else                                              116 else
101   Q = @                                           117   Q = @
102 endif                                             118 endif
103                                                   119 
104 # Disable command line variables (CFLAGS) over    120 # Disable command line variables (CFLAGS) override from top
105 # level Makefile (perf), otherwise build Makef    121 # level Makefile (perf), otherwise build Makefile will get
106 # the same command line setup.                    122 # the same command line setup.
107 MAKEOVERRIDES=                                    123 MAKEOVERRIDES=
108                                                   124 
109 all:                                              125 all:
110                                                   126 
111 OUTPUT ?= ./                                   << 
112 OUTPUT := $(abspath $(OUTPUT))/                << 
113 export srctree OUTPUT CC LD CFLAGS V              127 export srctree OUTPUT CC LD CFLAGS V
114 include $(srctree)/tools/build/Makefile.includ    128 include $(srctree)/tools/build/Makefile.include
115                                                   129 
116 SHARED_OBJDIR   := $(OUTPUT)sharedobjs/           130 SHARED_OBJDIR   := $(OUTPUT)sharedobjs/
117 STATIC_OBJDIR   := $(OUTPUT)staticobjs/           131 STATIC_OBJDIR   := $(OUTPUT)staticobjs/
118 BPF_IN_SHARED   := $(SHARED_OBJDIR)libbpf-in.o    132 BPF_IN_SHARED   := $(SHARED_OBJDIR)libbpf-in.o
119 BPF_IN_STATIC   := $(STATIC_OBJDIR)libbpf-in.o    133 BPF_IN_STATIC   := $(STATIC_OBJDIR)libbpf-in.o
                                                   >> 134 VERSION_SCRIPT  := libbpf.map
120 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h     135 BPF_HELPER_DEFS := $(OUTPUT)bpf_helper_defs.h
121 BPF_GENERATED   := $(BPF_HELPER_DEFS)          << 
122                                                   136 
123 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB    137 LIB_TARGET      := $(addprefix $(OUTPUT),$(LIB_TARGET))
124 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB    138 LIB_FILE        := $(addprefix $(OUTPUT),$(LIB_FILE))
125 PC_FILE         := $(addprefix $(OUTPUT),$(PC_    139 PC_FILE         := $(addprefix $(OUTPUT),$(PC_FILE))
126                                                   140 
127 TAGS_PROG := $(if $(shell which etags 2>/dev/n    141 TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)
128                                                   142 
129 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $    143 GLOBAL_SYM_COUNT = $(shell readelf -s --wide $(BPF_IN_SHARED) | \
130                            cut -d "@" -f1 | se    144                            cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' | \
131                            sed 's/\[.*\]//' |     145                            sed 's/\[.*\]//' | \
132                            awk '/GLOBAL/ && /D !! 146                            awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
133                            sort -u | wc -l)       147                            sort -u | wc -l)
134 VERSIONED_SYM_COUNT = $(shell readelf --dyn-sy    148 VERSIONED_SYM_COUNT = $(shell readelf --dyn-syms --wide $(OUTPUT)libbpf.so | \
135                               sed 's/\[.*\]//'    149                               sed 's/\[.*\]//' | \
136                               awk '/GLOBAL/ && !! 150                               awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}' | \
137                               grep -Eo '[^ ]+@    151                               grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | sort -u | wc -l)
138                                                   152 
139 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)            153 CMD_TARGETS = $(LIB_TARGET) $(PC_FILE)
140                                                   154 
141 all: fixdep                                       155 all: fixdep
142         $(Q)$(MAKE) all_cmd                       156         $(Q)$(MAKE) all_cmd
143                                                   157 
144 all_cmd: $(CMD_TARGETS) check                     158 all_cmd: $(CMD_TARGETS) check
145                                                   159 
146 $(SHARED_OBJDIR) $(STATIC_OBJDIR):             !! 160 $(BPF_IN_SHARED): force elfdep zdep bpfdep $(BPF_HELPER_DEFS)
147         $(Q)mkdir -p $@                        << 
148                                                << 
149 $(BPF_IN_SHARED): force $(BPF_GENERATED) | $(S << 
150         @(test -f ../../include/uapi/linux/bpf    161         @(test -f ../../include/uapi/linux/bpf.h -a -f ../../../include/uapi/linux/bpf.h && ( \
151         (diff -B ../../include/uapi/linux/bpf.    162         (diff -B ../../include/uapi/linux/bpf.h ../../../include/uapi/linux/bpf.h >/dev/null) || \
152         echo "Warning: Kernel ABI header at 't    163         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf.h' differs from latest version at 'include/uapi/linux/bpf.h'" >&2 )) || true
153         @(test -f ../../include/uapi/linux/bpf    164         @(test -f ../../include/uapi/linux/bpf_common.h -a -f ../../../include/uapi/linux/bpf_common.h && ( \
154         (diff -B ../../include/uapi/linux/bpf_    165         (diff -B ../../include/uapi/linux/bpf_common.h ../../../include/uapi/linux/bpf_common.h >/dev/null) || \
155         echo "Warning: Kernel ABI header at 't    166         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/bpf_common.h' differs from latest version at 'include/uapi/linux/bpf_common.h'" >&2 )) || true
                                                   >> 167         @(test -f ../../include/uapi/linux/netlink.h -a -f ../../../include/uapi/linux/netlink.h && ( \
                                                   >> 168         (diff -B ../../include/uapi/linux/netlink.h ../../../include/uapi/linux/netlink.h >/dev/null) || \
                                                   >> 169         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/netlink.h' differs from latest version at 'include/uapi/linux/netlink.h'" >&2 )) || true
                                                   >> 170         @(test -f ../../include/uapi/linux/if_link.h -a -f ../../../include/uapi/linux/if_link.h && ( \
                                                   >> 171         (diff -B ../../include/uapi/linux/if_link.h ../../../include/uapi/linux/if_link.h >/dev/null) || \
                                                   >> 172         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_link.h' differs from latest version at 'include/uapi/linux/if_link.h'" >&2 )) || true
156         @(test -f ../../include/uapi/linux/if_    173         @(test -f ../../include/uapi/linux/if_xdp.h -a -f ../../../include/uapi/linux/if_xdp.h && ( \
157         (diff -B ../../include/uapi/linux/if_x    174         (diff -B ../../include/uapi/linux/if_xdp.h ../../../include/uapi/linux/if_xdp.h >/dev/null) || \
158         echo "Warning: Kernel ABI header at 't    175         echo "Warning: Kernel ABI header at 'tools/include/uapi/linux/if_xdp.h' differs from latest version at 'include/uapi/linux/if_xdp.h'" >&2 )) || true
159         $(SILENT_MAKE) -C $(srctree)/tools/bui << 
160         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(S    176         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(SHARED_OBJDIR) CFLAGS="$(CFLAGS) $(SHLIB_FLAGS)"
161                                                   177 
162 $(BPF_IN_STATIC): force $(BPF_GENERATED) | $(S !! 178 $(BPF_IN_STATIC): force elfdep zdep bpfdep $(BPF_HELPER_DEFS)
163         $(SILENT_MAKE) -C $(srctree)/tools/bui << 
164         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(S    179         $(Q)$(MAKE) $(build)=libbpf OUTPUT=$(STATIC_OBJDIR)
165                                                   180 
166 $(BPF_HELPER_DEFS): $(srctree)/tools/include/u    181 $(BPF_HELPER_DEFS): $(srctree)/tools/include/uapi/linux/bpf.h
167         $(QUIET_GEN)$(srctree)/scripts/bpf_doc !! 182         $(QUIET_GEN)$(srctree)/scripts/bpf_helpers_doc.py --header \
168                 --file $(srctree)/tools/includ    183                 --file $(srctree)/tools/include/uapi/linux/bpf.h > $(BPF_HELPER_DEFS)
169                                                   184 
170 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBP    185 $(OUTPUT)libbpf.so: $(OUTPUT)libbpf.so.$(LIBBPF_VERSION)
171                                                   186 
172 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN !! 187 $(OUTPUT)libbpf.so.$(LIBBPF_VERSION): $(BPF_IN_SHARED)
173         $(QUIET_LINK)$(CC) $(CFLAGS) $(LDFLAGS !! 188         $(QUIET_LINK)$(CC) $(LDFLAGS) \
174                 --shared -Wl,-soname,libbpf.so    189                 --shared -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
175                 -Wl,--version-script=$(VERSION !! 190                 -Wl,--version-script=$(VERSION_SCRIPT) $^ -lelf -lz -o $@
176         @ln -sf $(@F) $(OUTPUT)libbpf.so          191         @ln -sf $(@F) $(OUTPUT)libbpf.so
177         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIB    192         @ln -sf $(@F) $(OUTPUT)libbpf.so.$(LIBBPF_MAJOR_VERSION)
178                                                   193 
179 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)               194 $(OUTPUT)libbpf.a: $(BPF_IN_STATIC)
180         $(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@    195         $(QUIET_LINK)$(RM) -f $@; $(AR) rcs $@ $^
181                                                   196 
182 $(OUTPUT)libbpf.pc:                               197 $(OUTPUT)libbpf.pc:
183         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefi    198         $(QUIET_GEN)sed -e "s|@PREFIX@|$(prefix)|" \
184                 -e "s|@LIBDIR@|$(libdir_SQ)|"     199                 -e "s|@LIBDIR@|$(libdir_SQ)|" \
185                 -e "s|@VERSION@|$(LIBBPF_VERSI    200                 -e "s|@VERSION@|$(LIBBPF_VERSION)|" \
186                 < libbpf.pc.template > $@         201                 < libbpf.pc.template > $@
187                                                   202 
188 check: check_abi check_version                 !! 203 check: check_abi
189                                                   204 
190 check_abi: $(OUTPUT)libbpf.so $(VERSION_SCRIPT !! 205 check_abi: $(OUTPUT)libbpf.so
191         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERS    206         @if [ "$(GLOBAL_SYM_COUNT)" != "$(VERSIONED_SYM_COUNT)" ]; then  \
192                 echo "Warning: Num of global s    207                 echo "Warning: Num of global symbols in $(BPF_IN_SHARED)"        \
193                      "($(GLOBAL_SYM_COUNT)) do    208                      "($(GLOBAL_SYM_COUNT)) does NOT match with num of"  \
194                      "versioned symbols in $^     209                      "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
195                      "Please make sure all LIB    210                      "Please make sure all LIBBPF_API symbols are"       \
196                      "versioned in $(VERSION_S    211                      "versioned in $(VERSION_SCRIPT)." >&2;              \
197                 readelf -s --wide $(BPF_IN_SHA    212                 readelf -s --wide $(BPF_IN_SHARED) |                     \
198                     cut -d "@" -f1 | sed 's/_v    213                     cut -d "@" -f1 | sed 's/_v[0-9]_[0-9]_[0-9].*//' |   \
199                     sed 's/\[.*\]//' |            214                     sed 's/\[.*\]//' |                                   \
200                     awk '/GLOBAL/ && /DEFAULT/    215                     awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
201                     sort -u > $(OUTPUT)libbpf_    216                     sort -u > $(OUTPUT)libbpf_global_syms.tmp;           \
202                 readelf --dyn-syms --wide $(OU    217                 readelf --dyn-syms --wide $(OUTPUT)libbpf.so |           \
203                     sed 's/\[.*\]//' |            218                     sed 's/\[.*\]//' |                                   \
204                     awk '/GLOBAL/ && /DEFAULT/ !! 219                     awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$NF}'|  \
205                     grep -Eo '[^ ]+@LIBBPF_' |    220                     grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |             \
206                     sort -u > $(OUTPUT)libbpf_    221                     sort -u > $(OUTPUT)libbpf_versioned_syms.tmp;        \
207                 diff -u $(OUTPUT)libbpf_global    222                 diff -u $(OUTPUT)libbpf_global_syms.tmp                  \
208                      $(OUTPUT)libbpf_versioned    223                      $(OUTPUT)libbpf_versioned_syms.tmp;                 \
209                 rm $(OUTPUT)libbpf_global_syms    224                 rm $(OUTPUT)libbpf_global_syms.tmp                       \
210                    $(OUTPUT)libbpf_versioned_s    225                    $(OUTPUT)libbpf_versioned_syms.tmp;                   \
211                 exit 1;                           226                 exit 1;                                                  \
212         fi                                        227         fi
213                                                   228 
214 HDR_MAJ_VERSION := $(shell grep -oE '^$(pound) << 
215 HDR_MIN_VERSION := $(shell grep -oE '^$(pound) << 
216                                                << 
217 check_version: $(VERSION_SCRIPT) libbpf_versio << 
218         @if [ "$(HDR_MAJ_VERSION)" != "$(LIBBP << 
219                 echo "Error: libbpf major vers << 
220                      "'$(HDR_MAJ_VERSION)' !=  << 
221                 exit 1;                        << 
222         fi                                     << 
223         @if [ "$(HDR_MIN_VERSION)" != "$(LIBBP << 
224                 echo "Error: libbpf minor vers << 
225                      "'$(HDR_MIN_VERSION)' !=  << 
226                 exit 1;                        << 
227         fi                                     << 
228                                                << 
229 define do_install_mkdir                           229 define do_install_mkdir
230         if [ ! -d '$(DESTDIR_SQ)$1' ]; then       230         if [ ! -d '$(DESTDIR_SQ)$1' ]; then             \
231                 $(INSTALL) -d -m 755 '$(DESTDI    231                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$1'; \
232         fi                                        232         fi
233 endef                                             233 endef
234                                                   234 
235 define do_install                                 235 define do_install
236         if [ ! -d '$(DESTDIR_SQ)$2' ]; then       236         if [ ! -d '$(DESTDIR_SQ)$2' ]; then             \
237                 $(INSTALL) -d -m 755 '$(DESTDI    237                 $(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2'; \
238         fi;                                       238         fi;                                             \
239         $(INSTALL) $(if $3,-m $3,) $1 '$(DESTD    239         $(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR_SQ)$2'
240 endef                                             240 endef
241                                                   241 
242 install_lib: all_cmd                              242 install_lib: all_cmd
243         $(call QUIET_INSTALL, $(LIB_TARGET)) \    243         $(call QUIET_INSTALL, $(LIB_TARGET)) \
244                 $(call do_install_mkdir,$(libd    244                 $(call do_install_mkdir,$(libdir_SQ)); \
245                 cp -fpR $(LIB_FILE) $(DESTDIR)    245                 cp -fpR $(LIB_FILE) $(DESTDIR)$(libdir_SQ)
246                                                   246 
247 SRC_HDRS := bpf.h libbpf.h btf.h libbpf_common !! 247 install_headers: $(BPF_HELPER_DEFS)
248             bpf_helpers.h bpf_tracing.h bpf_en !! 248         $(call QUIET_INSTALL, headers) \
249             skel_internal.h libbpf_version.h u !! 249                 $(call do_install,bpf.h,$(prefix)/include/bpf,644); \
250 GEN_HDRS := $(BPF_GENERATED)                   !! 250                 $(call do_install,libbpf.h,$(prefix)/include/bpf,644); \
251                                                !! 251                 $(call do_install,btf.h,$(prefix)/include/bpf,644); \
252 INSTALL_PFX := $(DESTDIR)$(prefix)/include/bpf !! 252                 $(call do_install,libbpf_util.h,$(prefix)/include/bpf,644); \
253 INSTALL_SRC_HDRS := $(addprefix $(INSTALL_PFX) !! 253                 $(call do_install,libbpf_common.h,$(prefix)/include/bpf,644); \
254 INSTALL_GEN_HDRS := $(addprefix $(INSTALL_PFX) !! 254                 $(call do_install,xsk.h,$(prefix)/include/bpf,644); \
255                                                !! 255                 $(call do_install,bpf_helpers.h,$(prefix)/include/bpf,644); \
256 $(INSTALL_SRC_HDRS): $(INSTALL_PFX)/%.h: %.h   !! 256                 $(call do_install,$(BPF_HELPER_DEFS),$(prefix)/include/bpf,644); \
257         $(call QUIET_INSTALL, $@) \            !! 257                 $(call do_install,bpf_tracing.h,$(prefix)/include/bpf,644); \
258                 $(call do_install,$<,$(prefix) !! 258                 $(call do_install,bpf_endian.h,$(prefix)/include/bpf,644); \
259                                                !! 259                 $(call do_install,bpf_core_read.h,$(prefix)/include/bpf,644);
260 $(INSTALL_GEN_HDRS): $(INSTALL_PFX)/%.h: $(OUT << 
261         $(call QUIET_INSTALL, $@) \            << 
262                 $(call do_install,$<,$(prefix) << 
263                                                << 
264 install_headers: $(BPF_GENERATED) $(INSTALL_SR << 
265         $(call QUIET_INSTALL, libbpf_headers)  << 
266                                                   260 
267 install_pkgconfig: $(PC_FILE)                     261 install_pkgconfig: $(PC_FILE)
268         $(call QUIET_INSTALL, $(PC_FILE)) \       262         $(call QUIET_INSTALL, $(PC_FILE)) \
269                 $(call do_install,$(PC_FILE),$    263                 $(call do_install,$(PC_FILE),$(libdir_SQ)/pkgconfig,644)
270                                                   264 
271 install: install_lib install_pkgconfig install    265 install: install_lib install_pkgconfig install_headers
272                                                   266 
273 clean: fixdep-clean                            !! 267 ### Cleaning rules
                                                   >> 268 
                                                   >> 269 config-clean:
                                                   >> 270         $(call QUIET_CLEAN, feature-detect)
                                                   >> 271         $(Q)$(MAKE) -C $(srctree)/tools/build/feature/ clean >/dev/null
                                                   >> 272 
                                                   >> 273 clean: config-clean
274         $(call QUIET_CLEAN, libbpf) $(RM) -rf     274         $(call QUIET_CLEAN, libbpf) $(RM) -rf $(CMD_TARGETS)                 \
275                 *~ .*.d .*.cmd LIBBPF-CFLAGS $ !! 275                 *~ .*.d .*.cmd LIBBPF-CFLAGS $(BPF_HELPER_DEFS)              \
276                 $(SHARED_OBJDIR) $(STATIC_OBJD    276                 $(SHARED_OBJDIR) $(STATIC_OBJDIR)                            \
277                 $(addprefix $(OUTPUT),            277                 $(addprefix $(OUTPUT),                                       \
278                             *.o *.a *.so *.so.    278                             *.o *.a *.so *.so.$(LIBBPF_MAJOR_VERSION) *.pc)
                                                   >> 279         $(call QUIET_CLEAN, core-gen) $(RM) $(OUTPUT)FEATURE-DUMP.libbpf
                                                   >> 280 
279                                                   281 
280 PHONY += force cscope tags check check_abi che !! 282 
                                                   >> 283 PHONY += force elfdep zdep bpfdep cscope tags
281 force:                                            284 force:
282                                                   285 
                                                   >> 286 elfdep:
                                                   >> 287         @if [ "$(feature-libelf)" != "1" ]; then echo "No libelf found"; exit 1 ; fi
                                                   >> 288 
                                                   >> 289 zdep:
                                                   >> 290         @if [ "$(feature-zlib)" != "1" ]; then echo "No zlib found"; exit 1 ; fi
                                                   >> 291 
                                                   >> 292 bpfdep:
                                                   >> 293         @if [ "$(feature-bpf)" != "1" ]; then echo "BPF API too old"; exit 1 ; fi
                                                   >> 294 
283 cscope:                                           295 cscope:
284         ls *.c *.h > cscope.files                 296         ls *.c *.h > cscope.files
285         cscope -b -q -I $(srctree)/include -f     297         cscope -b -q -I $(srctree)/include -f cscope.out
286                                                   298 
287 tags:                                             299 tags:
288         $(RM) -f TAGS tags                        300         $(RM) -f TAGS tags
289         ls *.c *.h | xargs $(TAGS_PROG) -a        301         ls *.c *.h | xargs $(TAGS_PROG) -a
290                                                   302 
291 # Declare the contents of the .PHONY variable     303 # Declare the contents of the .PHONY variable as phony.  We keep that
292 # information in a variable so we can use it i    304 # information in a variable so we can use it in if_changed and friends.
293 .PHONY: $(PHONY)                                  305 .PHONY: $(PHONY)
294                                                   306 
295 # Delete partially updated (corrupted) files o    307 # Delete partially updated (corrupted) files on error
296 .DELETE_ON_ERROR:                                 308 .DELETE_ON_ERROR:
297                                                << 
298 help:                                          << 
299         @echo 'libbpf common targets:'         << 
300         @echo '  HINT: use "V=1" to enable ver << 
301         @echo '  all     - build libraries and << 
302         @echo '  clean   - remove all generate << 
303         @echo '  check   - check ABI and versi << 
304         @echo ''                               << 
305         @echo 'libbpf install targets:'        << 
306         @echo '  HINT: use "prefix"(defaults t << 
307         @echo '        to adjust target destin << 
308         @echo '  install          - build and  << 
309         @echo '  install_headers  - install on << 
310         @echo ''                               << 
311         @echo 'libbpf make targets:'           << 
312         @echo '  tags    - use ctags to make t << 
313         @echo '  cscope  - use cscope to make  << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php